> ## Documentation Index
> Fetch the complete documentation index at: https://openfga.dev/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Check multiple authorizations in a single request

> The `BatchCheck` API functions nearly identically to `Check`, but instead of checking a single user-object relationship BatchCheck accepts a list of relationships to check and returns a map containing `BatchCheckItem` response for each check it received.

An associated `correlation_id` is required for each check in the batch. This ID is used to correlate a check to the appropriate response. It is a string consisting of only alphanumeric characters or hyphens with a maximum length of 36 characters. This `correlation_id` is used to map the result of each check to the item which was checked, so it must be unique for each item in the batch. We recommend using a UUID or ULID as the `correlation_id`, but you can use whatever unique identifier you need as long  as it matches this regex pattern: `^[\w\d-]{1,36}$`

> **Note:** The maximum number of checks that can be passed in the `BatchCheck` API is configurable using the environment variable: `[OPENFGA_MAX_CHECKS_PER_BATCH_CHECK](https://openfga.dev/docs/getting-started/setup-openfga/configuration#OPENFGA_MAX_CHECKS_PER_BATCH_CHECK)`. If `BatchCheck` is called using the SDK, the SDK can split the batch check requests for you.

For more details on how `Check` functions, review the docs for `/check`.

### Examples

#### A BatchCheckRequest
```json
{
  "checks": [
     {
       "tuple_key": {
         "object": "document:2021-budget"
         "relation": "reader",
         "user": "user:anne",
       },
       "contextual_tuples": {...}
       "context": {}
       "correlation_id": "01JA8PM3QM7VBPGB8KMPK8SBD5"
     },
     {
       "tuple_key": {
         "object": "document:2021-budget"
         "relation": "reader",
         "user": "user:bob",
       },
       "contextual_tuples": {...}
       "context": {}
       "correlation_id": "01JA8PMM6A90NV5ET0F28CYSZQ"
     }
   ]
}
```

Below is a possible response to the above request. Note that the result map's keys are the `correlation_id` values from the checked items in the request:
```json
{
   "result": {
     "01JA8PMM6A90NV5ET0F28CYSZQ": {
       "allowed": false, 
       "error": {"message": ""} 
    },
     "01JA8PM3QM7VBPGB8KMPK8SBD5": {
       "allowed": true, 
       "error": {"message": ""} 
    }
}
```




## OpenAPI

````yaml https://raw.githubusercontent.com/openfga/api/refs/heads/main/docs/openapiv3/apidocs.openapi.json post /stores/{store_id}/batch-check
openapi: 3.0.3
info:
  contact:
    email: community@openfga.dev
    name: OpenFGA
    url: https://openfga.dev
  description: >-
    A high performance and flexible authorization/permission engine built for
    developers and inspired by Google Zanzibar.
  license:
    name: Apache-2.0
    url: https://github.com/openfga/openfga/blob/main/LICENSE
  title: OpenFGA
  version: 1.x
servers: []
security: []
tags:
  - name: AuthZenService
  - name: OpenFGAService
paths:
  /stores/{store_id}/batch-check:
    post:
      tags:
        - Relationship Queries
      summary: Check multiple authorizations in a single request
      description: >
        The `BatchCheck` API functions nearly identically to `Check`, but
        instead of checking a single user-object relationship BatchCheck accepts
        a list of relationships to check and returns a map containing
        `BatchCheckItem` response for each check it received.


        An associated `correlation_id` is required for each check in the batch.
        This ID is used to correlate a check to the appropriate response. It is
        a string consisting of only alphanumeric characters or hyphens with a
        maximum length of 36 characters. This `correlation_id` is used to map
        the result of each check to the item which was checked, so it must be
        unique for each item in the batch. We recommend using a UUID or ULID as
        the `correlation_id`, but you can use whatever unique identifier you
        need as long  as it matches this regex pattern: `^[\w\d-]{1,36}$`


        > **Note:** The maximum number of checks that can be passed in the
        `BatchCheck` API is configurable using the environment variable:
        `[OPENFGA_MAX_CHECKS_PER_BATCH_CHECK](https://openfga.dev/docs/getting-started/setup-openfga/configuration#OPENFGA_MAX_CHECKS_PER_BATCH_CHECK)`.
        If `BatchCheck` is called using the SDK, the SDK can split the batch
        check requests for you.


        For more details on how `Check` functions, review the docs for `/check`.


        ### Examples


        #### A BatchCheckRequest

        ```json

        {
          "checks": [
             {
               "tuple_key": {
                 "object": "document:2021-budget"
                 "relation": "reader",
                 "user": "user:anne",
               },
               "contextual_tuples": {...}
               "context": {}
               "correlation_id": "01JA8PM3QM7VBPGB8KMPK8SBD5"
             },
             {
               "tuple_key": {
                 "object": "document:2021-budget"
                 "relation": "reader",
                 "user": "user:bob",
               },
               "contextual_tuples": {...}
               "context": {}
               "correlation_id": "01JA8PMM6A90NV5ET0F28CYSZQ"
             }
           ]
        }

        ```


        Below is a possible response to the above request. Note that the result
        map's keys are the `correlation_id` values from the checked items in the
        request:

        ```json

        {
           "result": {
             "01JA8PMM6A90NV5ET0F28CYSZQ": {
               "allowed": false, 
               "error": {"message": ""} 
            },
             "01JA8PM3QM7VBPGB8KMPK8SBD5": {
               "allowed": true, 
               "error": {"message": ""} 
            }
        }

        ```
      operationId: BatchCheck
      parameters:
        - in: path
          name: store_id
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BatchCheckBody'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BatchCheckResponse'
          description: A successful response.
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ValidationErrorMessageResponse'
          description: Request failed due to invalid input.
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthenticatedResponse'
          description: Not authenticated.
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenResponse'
          description: Forbidden.
        '404':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PathUnknownErrorMessageResponse'
          description: Request failed due to incorrect path.
        '409':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AbortedMessageResponse'
          description: Request was aborted due a transaction conflict.
        '422':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnprocessableContentMessageResponse'
          description: Request timed out due to excessive request throttling.
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InternalErrorMessageResponse'
          description: Request failed due to internal server error.
      x-codeSamples:
        - lang: node
          label: Node.js
          source: >-
            const { OpenFgaClient, ConsistencyPreference } =
            require('@openfga/sdk');


            const fgaClient = new OpenFgaClient({
              apiUrl: process.env.FGA_API_URL,
              storeId: process.env.FGA_STORE_ID,
              authorizationModelId: process.env.FGA_MODEL_ID, // Optional; requests can override this.
            });


            async function main() {
                const body = {
                  "checks": [
                    {
                      "user": "user:anne",
                      "relation": "reader",
                      "object": "document:budget",
                      "correlationId": "budget-reader"
                    }
                  ]
                };
                const options = {
                  "maxBatchSize": 50,
                  "maxParallelRequests": 10
                };
                const response = await fgaClient.batchCheck(body, options);
            }


            main().catch((error) => {
                console.error(error);
                process.exitCode = 1;
            });
        - lang: go
          label: Go
          source: |-
            package main

            import (
                "context"
                "os"

                openfga "github.com/openfga/go-sdk"
                . "github.com/openfga/go-sdk/client"
            )

            func main() {
                fgaClient, err := NewSdkClient(&ClientConfiguration{
                    ApiUrl: os.Getenv("FGA_API_URL"),
                    StoreId: os.Getenv("FGA_STORE_ID"),
                    AuthorizationModelId: os.Getenv("FGA_MODEL_ID"), // Optional; requests can override this.
                })
                if err != nil {
                    panic(err)
                }
                
                body := ClientBatchCheckRequest{
                  Checks: []ClientBatchCheckItem{
                    ClientBatchCheckItem{
                      User: "user:anne",
                      Relation: "reader",
                      Object: "document:budget",
                      CorrelationId: "budget-reader",
                    },
                  },
                }
                options := BatchCheckOptions{
                  MaxBatchSize: openfga.PtrInt32(50),
                  MaxParallelRequests: openfga.PtrInt32(10),
                }
                data, err := fgaClient.BatchCheck(context.Background()).Body(body).Options(options).Execute()
                if err != nil {
                    panic(err)
                }
                _ = data
            }
        - lang: dotnet
          label: .NET
          source: |-
            using System.Collections.Generic;
            using OpenFga.Sdk.Client;
            using OpenFga.Sdk.Client.Model;
            using OpenFga.Sdk.Model;
            using Environment = System.Environment;

            var fgaClient = new OpenFgaClient(new ClientConfiguration() {
              ApiUrl = Environment.GetEnvironmentVariable("FGA_API_URL"),
              StoreId = Environment.GetEnvironmentVariable("FGA_STORE_ID"),
              AuthorizationModelId = Environment.GetEnvironmentVariable("FGA_MODEL_ID"), // Optional; requests can override this.
            });

            var body = new ClientBatchCheckRequest {
              Checks = new List<ClientBatchCheckItem> {
                new ClientBatchCheckItem {
                  User = "user:anne",
                  Relation = "reader",
                  Object = "document:budget",
                  CorrelationId = "budget-reader",
                },
              },
            };
            var options = new ClientBatchCheckOptions {
              MaxBatchSize = 50,
              MaxParallelRequests = 10,
            };
            var response = await fgaClient.BatchCheck(body, options);
        - lang: python
          label: Python
          source: >-
            import asyncio

            import os

            from openfga_sdk.client import OpenFgaClient, ClientConfiguration

            from openfga_sdk.client.models import ClientBatchCheckItem,
            ClientBatchCheckRequest, ClientTuple

            from openfga_sdk.models import RelationshipCondition


            async def main():
                configuration = ClientConfiguration(
                    api_url=os.environ.get("FGA_API_URL"),
                    store_id=os.environ.get("FGA_STORE_ID"),
                    authorization_model_id=os.environ.get("FGA_MODEL_ID"), # Optional; requests can override this.
                )
                async with OpenFgaClient(configuration) as fga_client:
                    body = ClientBatchCheckRequest(
                      checks=[
                        ClientBatchCheckItem(
                          user="user:anne",
                          relation="reader",
                          object="document:budget",
                          correlation_id="budget-reader",
                        )
                      ],
                    )
                    options = {
                    
                    }
                    response = await fga_client.batch_check(body, options)

            asyncio.run(main())
        - lang: java
          label: Java
          source: |-
            import dev.openfga.sdk.api.client.OpenFgaClient;
            import dev.openfga.sdk.api.configuration.ClientConfiguration;
            import dev.openfga.sdk.api.configuration.*;
            import dev.openfga.sdk.api.client.model.*;
            import dev.openfga.sdk.api.model.*;
            import java.util.List;
            import java.util.Map;
            import java.util.ArrayList;

            public class Example {
                public static void main(String[] args) throws Exception {
                    var config = new ClientConfiguration()
                        .apiUrl(System.getenv("FGA_API_URL"))
                        .storeId(System.getenv("FGA_STORE_ID"))
                        .authorizationModelId(System.getenv("FGA_MODEL_ID")); // Optional; requests can override this.
                    var fgaClient = new OpenFgaClient(config);
                    
                    var body = new ClientBatchCheckRequest()
                      .checks(java.util.Arrays.asList(new ClientBatchCheckItem()
                        .user("user:anne")
                        .relation("reader")
                        ._object("document:budget")
                        .correlationId("budget-reader")));
                    var options = new ClientBatchCheckOptions()
                      .maxBatchSize(50)
                      .maxParallelRequests(10);
                    var response = fgaClient.batchCheck(body, options).get();
                }
            }
        - lang: bash
          label: curl
          source: >-
            # Set FGA_API_URL to the URL of your OpenFGA server.

            # Set FGA_STORE_ID to your store ID.

            # These examples use a server with authentication disabled.

            # For authenticated servers, see
            /docs/getting-started/setup-sdk-client.


            curl -X POST "$FGA_API_URL/stores/$FGA_STORE_ID/batch-check" \
              -H "content-type: application/json" \
              -d '{
              "authorization_model_id": "'"$FGA_MODEL_ID"'",
              "checks": [
                {
                  "tuple_key": {
                    "user": "user:anne",
                    "relation": "reader",
                    "object": "document:budget"
                  },
                  "correlation_id": "budget-reader"
                }
              ]
            }'
components:
  schemas:
    BatchCheckBody:
      properties:
        authorization_model_id:
          example: 01G5JAVJ41T49E9TT3SKVS7X1J
          type: string
        checks:
          items:
            allOf:
              - $ref: '#/components/schemas/BatchCheckItem'
              - type: object
          minItems: 1
          type: array
        consistency:
          $ref: '#/components/schemas/ConsistencyPreference'
      required:
        - checks
      type: object
    BatchCheckResponse:
      properties:
        result:
          additionalProperties:
            $ref: '#/components/schemas/BatchCheckSingleResult'
          description: >-
            Map keys are the `correlation_id` values from the `BatchCheckItems`
            in the request.
          example:
            1cd93d8c-8e45-43c6-9a15-cbb3c7f394bc:
              allowed: true
              error:
                message: ''
          type: object
      type: object
    ValidationErrorMessageResponse:
      example:
        code: validation_error
        message: Generic validation error
      properties:
        code:
          $ref: '#/components/schemas/ErrorCode'
        message:
          type: string
      type: object
    UnauthenticatedResponse:
      example:
        code: unauthenticated
        message: unauthenticated
      properties:
        code:
          $ref: '#/components/schemas/ErrorCode'
        message:
          type: string
      type: object
    ForbiddenResponse:
      example:
        code: forbidden
        message: the principal is not authorized to perform the action
      properties:
        code:
          $ref: '#/components/schemas/AuthErrorCode'
        message:
          type: string
      type: object
    PathUnknownErrorMessageResponse:
      example:
        code: undefined_endpoint
        message: Endpoint not enabled
      properties:
        code:
          $ref: '#/components/schemas/NotFoundErrorCode'
        message:
          type: string
      type: object
    AbortedMessageResponse:
      example:
        code: '10'
        message: transaction conflict
      properties:
        code:
          type: string
        message:
          type: string
      type: object
    UnprocessableContentMessageResponse:
      example:
        code: throttled_timeout_error
        message: timeout due to throttling on complex request
      properties:
        code:
          $ref: '#/components/schemas/UnprocessableContentErrorCode'
        message:
          type: string
      type: object
    InternalErrorMessageResponse:
      example:
        code: internal_error
        message: Internal Server Error
      properties:
        code:
          $ref: '#/components/schemas/InternalErrorCode'
        message:
          type: string
      type: object
    BatchCheckItem:
      properties:
        context:
          type: object
        contextual_tuples:
          $ref: '#/components/schemas/ContextualTupleKeys'
        correlation_id:
          description: >-
            correlation_id must be a string containing only letters, numbers, or
            hyphens, with length ≤ 36 characters.
          example: 1cd93d8c-8e45-43c6-9a15-cbb3c7f394bc
          type: string
        tuple_key:
          $ref: '#/components/schemas/CheckRequestTupleKey'
      required:
        - tuple_key
        - correlation_id
      type: object
    ConsistencyPreference:
      default: UNSPECIFIED
      description: |-
        Controls the consistency preferences when calling the query APIs.

         - UNSPECIFIED: Default if not set. Behavior will be the same as MINIMIZE_LATENCY.
         - MINIMIZE_LATENCY: Minimize latency at the potential expense of lower consistency.
         - HIGHER_CONSISTENCY: Prefer higher consistency, at the potential expense of increased latency.
      enum:
        - UNSPECIFIED
        - MINIMIZE_LATENCY
        - HIGHER_CONSISTENCY
      example: MINIMIZE_LATENCY
      type: string
    BatchCheckSingleResult:
      properties:
        allowed:
          type: boolean
        error:
          $ref: '#/components/schemas/CheckError'
      type: object
    ErrorCode:
      default: no_error
      enum:
        - no_error
        - validation_error
        - authorization_model_not_found
        - authorization_model_resolution_too_complex
        - invalid_write_input
        - cannot_allow_duplicate_tuples_in_one_request
        - cannot_allow_duplicate_types_in_one_request
        - cannot_allow_multiple_references_to_one_relation
        - invalid_continuation_token
        - invalid_tuple_set
        - invalid_check_input
        - invalid_expand_input
        - unsupported_user_set
        - invalid_object_format
        - write_failed_due_to_invalid_input
        - authorization_model_assertions_not_found
        - latest_authorization_model_not_found
        - type_not_found
        - relation_not_found
        - empty_relation_definition
        - invalid_user
        - invalid_tuple
        - unknown_relation
        - store_id_invalid_length
        - assertions_too_many_items
        - id_too_long
        - authorization_model_id_too_long
        - tuple_key_value_not_specified
        - tuple_keys_too_many_or_too_few_items
        - page_size_invalid
        - param_missing_value
        - difference_base_missing_value
        - subtract_base_missing_value
        - object_too_long
        - relation_too_long
        - type_definitions_too_few_items
        - type_invalid_length
        - type_invalid_pattern
        - relations_too_few_items
        - relations_too_long
        - relations_invalid_pattern
        - object_invalid_pattern
        - query_string_type_continuation_token_mismatch
        - exceeded_entity_limit
        - invalid_contextual_tuple
        - duplicate_contextual_tuple
        - invalid_authorization_model
        - unsupported_schema_version
        - cancelled
        - invalid_start_time
      type: string
    AuthErrorCode:
      default: no_auth_error
      enum:
        - no_auth_error
        - auth_failed_invalid_subject
        - auth_failed_invalid_audience
        - auth_failed_invalid_issuer
        - invalid_claims
        - auth_failed_invalid_bearer_token
        - bearer_token_missing
        - unauthenticated
        - forbidden
      type: string
    NotFoundErrorCode:
      default: no_not_found_error
      enum:
        - no_not_found_error
        - undefined_endpoint
        - store_id_not_found
        - unimplemented
      type: string
    UnprocessableContentErrorCode:
      default: no_throttled_error_code
      enum:
        - no_throttled_error_code
        - throttled_timeout_error
      type: string
    InternalErrorCode:
      default: no_internal_error
      enum:
        - no_internal_error
        - internal_error
        - deadline_exceeded
        - already_exists
        - resource_exhausted
        - failed_precondition
        - aborted
        - out_of_range
        - unavailable
        - data_loss
      type: string
    ContextualTupleKeys:
      properties:
        tuple_keys:
          items:
            allOf:
              - $ref: '#/components/schemas/TupleKey'
              - type: object
          maxItems: 100
          type: array
      required:
        - tuple_keys
      type: object
    CheckRequestTupleKey:
      properties:
        object:
          example: document:2021-budget
          maxLength: 256
          type: string
        relation:
          example: reader
          maxLength: 50
          type: string
        user:
          example: user:anne
          maxLength: 512
          type: string
      required:
        - user
        - relation
        - object
      type: object
    CheckError:
      properties:
        input_error:
          $ref: '#/components/schemas/ErrorCode'
        internal_error:
          $ref: '#/components/schemas/InternalErrorCode'
        message:
          type: string
      type: object
    TupleKey:
      properties:
        condition:
          $ref: '#/components/schemas/RelationshipCondition'
        object:
          example: document:2021-budget
          maxLength: 256
          type: string
        relation:
          example: reader
          maxLength: 50
          type: string
        user:
          example: user:anne
          maxLength: 512
          type: string
      required:
        - user
        - relation
        - object
      type: object
    RelationshipCondition:
      properties:
        context:
          description: >-
            Additional context/data to persist along with the condition.

            The keys must match the parameters defined by the condition, and the
            value types must

            match the parameter type definitions.
          type: object
        name:
          description: >-
            A reference (by name) of the relationship condition defined in the
            authorization model.
          example: condition1
          maxLength: 256
          type: string
      required:
        - name
      type: object

````